// MAHONEKO ORANGE-inside Version
// (c) bomarn

//about Image data (bk01)
//http://www.picosoft.co.jp/ORANGE-light/image1616.html
//Copyright (c) 2019 Picosoft Co., Ltd.
//Made by Kaori Hanatsumi

' ボタンの定義
BUTTON_UP = 5
BUTTON_DOWN = 8
BUTTON_LEFT = 7
BUTTON_RIGHT = 6
BUTTON_B = 10
BUTTON_START = 9
BUTTON_SELECT = 3

' 色の定義
WHITE = rgb(255, 255, 255)
RED = rgb(255, 0, 0)
GREEN = rgb(0, 255, 0)
BLUE = rgb(0, 0, 255)
ORANGE = rgb(255, 165, 0)
KUSA = 0x6D

IMG_EMI = getmptr()
mdata 0x4F, 0xE8, 0x5F, 0xF0, 0x5F, 0xF8, 0x58, 0x18, 0x52, 0x5C, 0x4A, 0x5C, 0x48, 0x1E, 0xA4, 0x3D, 0x5F, 0xEE, 0x5F, 0xF0, 0x03, 0xF8, 0x00, 0x18, 0x03, 0x5C, 0x07, 0xEE, 0x0A, 0x50, 0x1C, 0x38
IMG_NEKO = getmptr()
mdata 0x10, 0x20, 0x18, 0x64, 0x1F, 0xEC, 0x3F, 0xFC, 0x38, 0x2C, 0x74, 0xBE, 0x54, 0xAE, 0x10, 0x26, 0x08, 0x46, 0x37, 0xB2, 0x37, 0xB1, 0x07, 0x80, 0x0F, 0xC0, 0x1F, 0xE4, 0x04, 0x98, 0x06, 0xC0
IMG_TEKI = getmptr()
mdata 0x02, 0x80, 0x06, 0xC0, 0x0E, 0xE0, 0x1E, 0xF0, 0x12, 0x94, 0x52, 0x96, 0xDE, 0xF6, 0xDE, 0xF7, 0xEE, 0xE7, 0xE6, 0xD3, 0xC2, 0xB5, 0xA4, 0x7A, 0x4F, 0xF8, 0x1F, 0xF8, 0x1C, 0x1C, 0x38, 0x0E
IMG_BK01 = getmptr()
mdata 0x00, 0x00, 0x00, 0x80, 0x01, 0xC0, 0x43, 0xE1, 0x01, 0xC0, 0x08, 0x88, 0x00, 0x80, 0x20, 0x02, 0x78, 0x0F, 0x20, 0x02, 0x00, 0x80, 0x08, 0x88, 0x01, 0xC0, 0x43, 0xE1, 0x01, 0xC0, 0x00, 0x80

//while !in(BUTTON_START)
//wend

loop:
cls 2
x = 18:y = 10
nx = 22:ny = 10
tx = 2:ty = 6

score = 0
emi = sprnew(0,x*8,y*8,16,16,IMG_EMI,RED,0)
sprdsp emi,1
neko = sprnew(1,nx*8,ny*8,16,16,IMG_NEKO,BLUE,0)
sprdsp neko,1
teki = sprnew(2,tx*8,ty*8,16,16,IMG_TEKI,WHITE,0)
sprdsp teki,1
baku = sprnew(3,0,0,16,16,IMG_BK01,ORANGE,0)

for i=1 to 30
	gp(i,5,KUSA,GREEN)
	gp(i,18,KUSA,GREEN)
next
gprint 6*8,3*8,"SCORE: 0",WHITE,0

f=1
while in(BUTTON_START) && f
	speed = (speed + 1)%2
	move_emi()
	if !in(BUTTON_B) then call_neko() else move_neko(speed)
	move_teki(speed)
	sprmov emi,x*8,y*8
	sprmov neko,nx*8,ny*8
	sprmov teki,tx*8,ty*8
	if sprhit(neko, teki) then f=0:goto skip
	if sprhit(emi, teki) then beat_teki()
skip:
	pause 150
wend
if f=1 then end

gprint 10*8,21*8,"GAME OVER",WHITE,0
gprint 8*8,23*8,"Replay:SELECT",ORANGE,0
gprint 8*8,24*8,"Exit  :START",ORANGE,0
BEEP 4,500

f=1
while in(BUTTON_START) && f
	if !in(BUTTON_SELECT) then f=0
wend
if f=0 then goto loop
end


def move_emi() {
	x = x - !in(BUTTON_LEFT)*(x>2) + !in(BUTTON_RIGHT)*(x<28)
	y = y - !in(BUTTON_UP)*(y>6) + !in(BUTTON_DOWN)*(y<16)
}
def call_neko() {
	nx = nx - (x<nx) + (x>nx)
	ny = ny - (y<ny) + (y>ny)
}
def move_neko(f) {
	var bx
	var by
	if f then return
	bx=nx:by=ny
	nx = nx - 1 + rnd(2)*2
	ny = ny - 1 + rnd(2)*2
	if nx<2 or nx>28 or ny<6 or ny>16 then nx=bx:ny=by
}
def move_teki(f) {
	if f then return
	tx = tx - (nx<tx) + (nx>tx)
	ty = ty - (ny<ty) + (ny>ty)
}
def beat_teki() {
	sprmov baku,tx*8,ty*8
	sprdsp baku,1
	se()
	sprdsp baku,0
	score = score + 1
	gprint 13*8,3*8,score*10,WHITE,0
	tx = 2 + rnd(2)*26 : ty = 6 + rnd(10) 
}
def se() {
	var i
	i=47
	while i
		beep i,10
		i=i-1
	wend
}
def gp(x,y,c,col) {
	gprint x*8,y*8,chr$(c),col,0
}